<?php class basenote extends baseobject {

	protected static $fields=array(
			'name'=>validator::ANY, //actually required but is auto generated
			'text'=>validator::ANY,
			'userid'=>array(validator::REQUIRED, validator::INTEGER),
			'parentid'=>array(validator::REQUIRED, validator::INTEGER),
	);
	
	protected static $helpTexts=array(
	);

    /**
     * @param string $key
     * @param string $value
     * @param array $request
     * @return array
     * @throws BadRequestException
     * @throws NotFoundException
     * @throws ServerException
     */
	public static function getByProperty($key, $value, $request=array()){
		$keys=array_keys(self::getFieldValidations());
		if(!in_array($key, $keys) &&'projectid'!=$key){
			throw new BadRequestException('Property '.$key.' not recognised on note');
		}
		$sqlStatement='SELECT SQL_CALC_FOUND_ROWS baseobject.createtime AS createtime, user.fullname AS username, note.*
				FROM baseobject, note, user, project
				WHERE baseobject.id=note.id AND user.id=note.userid 
				AND note.projectid=project.id
				AND note.'.$key.'=:val ';
		$sqlStatement.=static::getProjectClause('read');
		$sqlStatement.='ORDER BY baseobject.createtime DESC';
		$sqlStatement.=database::getLimitClause($request);
		$params=array(':val'=>$value);
		return database::queryGetAll($sqlStatement,$params);
	}

    /**
     * @param array $request
     * @return array|void
     * @throws BadRequestException
     */
	public static function getAll($request=array()){
		throw new BadRequestException('getAll not implemented on note');
	}

    /**
     * @param string $name
     * @return array|void
     * @throws BadRequestException
     */
	public static function getByName($name){
		throw new BadRequestException('getByName not implemented on note');
	}

    /**
     * @param array $request
     * @return array
     * @throws BadRequestException
     * @throws ForbiddenException
     * @throws NotFoundException
     * @throws ServerException
     */
	public static function create($request=array()){
		$parent=baseobject::getById($request['parentid']);
		$request['userid']=session::getUserId();
		$request['projectid']=$parent['projectid'];
		$request['name']='obj'.$parent['id'].'_user'.$request['userid'].'_'.microtime();
		return parent::create($request);
	}

}